/* tslint:disable */
/* eslint-disable */
/**
 * OpenAPI definition
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: v0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import {exists, mapValues} from '../runtime';
import {
  TransactionMessageCollateralDto,
  TransactionMessageCollateralDtoFromJSON,
  TransactionMessageCollateralDtoFromJSONTyped,
  TransactionMessageCollateralDtoToJSON,
} from './TransactionMessageCollateralDto';

/**
 *
 * @export
 * @interface TransferRequest
 */
export interface TransferRequest {
  /**
   *
   * @type {string}
   * @memberof TransferRequest
   */
  senderBic: string;
  /**
   *
   * @type {string}
   * @memberof TransferRequest
   */
  recipientBic: string;
  /**
   * Initiating party's IBAN number
   * @type {string}
   * @memberof TransferRequest
   */
  senderAccount: string;
  /**
   * Counterparty IBAN number
   * @type {string}
   * @memberof TransferRequest
   */
  recipientAccount: string;
  /**
   * Transaction amount
   * @type {number}
   * @memberof TransferRequest
   */
  amount: number;
  /**
   * Transaction currency
   * @type {string}
   * @memberof TransferRequest
   */
  currency: string;
  /**
   *
   * @type {string}
   * @memberof TransferRequest
   */
  endToEndId: string;
  /**
   *
   * @type {Date}
   * @memberof TransferRequest
   */
  requestDate?: Date;
  /**
   *
   * @type {Date}
   * @memberof TransferRequest
   */
  validUntil?: Date;
  /**
   *
   * @type {string}
   * @memberof TransferRequest
   */
  referenceInfo?: string;
  /**
   *
   * @type {TransactionMessageCollateralDto}
   * @memberof TransferRequest
   */
  collateral?: TransactionMessageCollateralDto;
}

export function TransferRequestFromJSON(json: any): TransferRequest {
  return TransferRequestFromJSONTyped(json, false);
}

export function TransferRequestFromJSONTyped(
  json: any,
  ignoreDiscriminator: boolean
): TransferRequest {
  if (json === undefined || json === null) {
    return json;
  }
  return {
    senderBic: json['senderBic'],
    recipientBic: json['recipientBic'],
    senderAccount: json['senderAccount'],
    recipientAccount: json['recipientAccount'],
    amount: json['amount'],
    currency: json['currency'],
    endToEndId: json['endToEndId'],
    requestDate: !exists(json, 'requestDate')
      ? undefined
      : new Date(json['requestDate']),
    validUntil: !exists(json, 'validUntil')
      ? undefined
      : new Date(json['validUntil']),
    referenceInfo: !exists(json, 'referenceInfo')
      ? undefined
      : json['referenceInfo'],
    collateral: !exists(json, 'collateral')
      ? undefined
      : TransactionMessageCollateralDtoFromJSON(json['collateral']),
  };
}

export function TransferRequestToJSON(value?: TransferRequest | null): any {
  if (value === undefined) {
    return undefined;
  }
  if (value === null) {
    return null;
  }
  return {
    senderBic: value.senderBic,
    recipientBic: value.recipientBic,
    senderAccount: value.senderAccount,
    recipientAccount: value.recipientAccount,
    amount: value.amount,
    currency: value.currency,
    endToEndId: value.endToEndId,
    requestDate:
      value.requestDate === undefined
        ? undefined
        : value.requestDate.toISOString(),
    validUntil:
      value.validUntil === undefined
        ? undefined
        : value.validUntil.toISOString(),
    referenceInfo: value.referenceInfo,
    collateral: TransactionMessageCollateralDtoToJSON(value.collateral),
  };
}
